'use strict';

exports.__esModule = true;

var _path = require('path');

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

var _camelcase = require('camelcase');

var _camelcase2 = _interopRequireDefault(_camelcase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**  EXPORT ALL FUNCTIONS
 *
 *   Loads all files that have a specific extension
 *   Default extension is .f.js
 *   Exports a cloud function matching the file name
 *
 *   Based on this thread:
 *     https://github.com/firebase/functions-samples/issues/170
 */
/* eslint-disable */
require = require('esm')(module /*, options*/);


var loadFunctions = function loadFunctions(folder, exports) {
  var group = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var extension = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '.f.js';

  if (group) {
    var folders = _glob2.default.sync('./*/', {
      cwd: (0, _path.resolve)(folder),
      ignore: './node_modules/**'
    });

    for (var i = 0; i < folders.length; i++) {
      var fol = folders[i];
      var folderName = fol.split('.').join('').split('/').join('');

      var folderFiles = _glob2.default.sync('./**/*' + extension, {
        cwd: (0, _path.resolve)(fol),
        ignore: './node_modules/**'
      });

      var ex = {};

      for (var y = 0; y < folderFiles.length; y++) {
        var file = folderFiles[y];

        var functionName = (0, _camelcase2.default)(file.split(extension).join('').split('/').join('_')); // Strip off '.f.js'

        var mod = require((0, _path.resolve)(fol, file));
        ex[functionName] = mod.default || mod;
      }
      if (Object.keys(ex).length) {
        exports[folderName] = ex;
      }
    }
  } else {
    var files = _glob2.default.sync('./**/*' + extension, {
      cwd: (0, _path.resolve)(folder),
      ignore: './node_modules/**'
    });

    for (var f = 0, fl = files.length; f < fl; f++) {
      var _file = files[f];

      var _functionName = (0, _camelcase2.default)(_file.split(extension).join('').split('/').join('_')); // Strip off '.f.js'

      var _mod = require((0, _path.resolve)(folder, _file));
      exports[_functionName] = _mod.default || _mod;
    }
  }
};

exports.default = loadFunctions;

/* eslint-enable */

module.exports = exports['default'];