'use strict';

var admin = require('firebase-admin');

module.exports = {
  notifyUser: function notifyUser(userUid, payload) {
    var tokensBasePath = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'notification_tokens';

    console.log(userUid, payload);

    return admin.database().ref('/' + tokensBasePath + '/' + userUid).once('value').then(function (snapshot) {
      var registrationTokens = [];

      snapshot.forEach(function (token) {
        if (token.val()) {
          registrationTokens.push(token.key);
        }
      });

      if (registrationTokens.length) {
        return admin.messaging().sendToDevice(registrationTokens, payload);
      } else {
        console.log('Not tokens registered');
        return null;
      }
    });
  }
};