'use strict';

var admin = require('firebase-admin');

// Source: https://firebase.google.com/docs/auth/admin/manage-users
var listAllUsers = function listAllUsers() {
  var userIds = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var nextPageToken = arguments[1];

  // List batch of users, 1000 at a time.
  return admin.auth().listUsers(1000, nextPageToken).then(function (resp) {
    if (resp.pageToken) {
      // List next batch of users.
      return listAllUsers(userIds.concat(resp.users), resp.pageToken);
    }
    return userIds.concat(resp.users);
  });
};

module.exports = {
  listAllUsers: listAllUsers
};